function [newarr] = java2matArray(arr)

if vl_isoctave(),
  if isempty(arr),
      newarr = zeros(0,1);
      return
  end

  tmp = javaObject('org.octave.Matrix', arr);
  d1 = tmp.getDim(0);
  d2 = tmp.getDim(1);
  d3 = tmp.getDim(2);
  
  if d3 ~= -1,
     error('Only up to two dimensions are supported.');
  end
  
  if d2 == -1 || d1 == 1,
    newarr = zeros(1,max(d1,d2));
    for i = 1:max(d1,d2),
       newarr(i) = arr(i);
    end
  else
    newarr = zeros(d1,d2);
    for i = 1:d1,
       for j = 2:d2,
          newarr(i,j) = arr(i,j);
       end
    end
  end
else
  newarr = arr;
end

end
