#include <cuda.h>
#include "device_functions.h"

extern "C"
//__global__ void FacilityLocation(int n, float *a, float *S, float *val)
__global__ void FacilityLocation(int nS, int* S, int nrElements, float *sim, float* val)
{
   __shared__ float s[100];
   
   int i = threadIdx.x;
   
   // find max
      float max = -1.0;
      float *start = sim + i*nrElements - 1;
	   for (int j = 0; j < nS; j++) {
	     float ttval = *(start + S[j]);
	     //max = fmaxf(ttval, max);
	     if (ttval > max)
		max = ttval;
	   }
     s[i] = max;
     //atomicAdd(val, max);
   
   __syncthreads();
   
   // sum up
   if (i == 0) {
	   float tval = 0.0;
	   for (int j = 0; j < 100; j++) {
	     tval += s[j];
	   }

	   *val = tval / 100.0; 
   } 
}

/** WORKING 
__global__ void FacilityLocation(int nS, int* S, int nrElements, float *sim, float* val)
{
  // sim points to 100x100 matrix
   // int i = blockIdx.x * blockDim.x + threadIdx.x;
   // if (i<n)
   // {
   //     sum[i] = a[i] + b[i];
   // }
   
   __shared__ double s[100];
   
   int k = threadIdx.x;
   
   // find max
   for (int i = 0; i < 100; i++){
      float max = -1.0;
	   for (int j = 0; j < nS; j++) {
	     float ttval = *(sim + i + (S[j]-1)*nrElements);
	     if (ttval > max)
		max = ttval;
	   }
     s[i] = max;
   }
   
   __syncthreads();
   
   // sum up
   float tval = 0.0;
   for (int j = 0; j < 100; j++) {
     tval += s[j];
   }

   *val = tval / 100.0;
} **/
