import static org.junit.Assert.assertEquals;
import static org.junit.Assert.fail;

import org.junit.Test;

public class FacilityLocationTest {
	private static int nrElements = 100;
	
	@Test
	public void testEvalIntArray() {
		// setup object
		double[][] sim = new double[nrElements][nrElements];
		for (int i = 0; i < nrElements; i++) {
			for (int j = 0; j <= i; j++) {
				sim[i][j] = (i == j ? 1.0 : 1.0 / (i + j));
				sim[j][i] = sim[i][j];
			}
		}
		
		FacilityLocation FL = new FacilityLocation(sim);
		int[] S = new int[] { 1, 2, 3, 4, 5, 6, 7, 8, 9, 10 };
		double val = FL.eval(S);
		
		assertEquals(val, 1.0, 1e-6);
		
		fail("Not yet implemented");
	}
}
