import java.util.ArrayList;
import java.util.HashSet;
import java.util.List;
import java.util.Set;

public class GreedyUnlimited {
	private Function function;
	
	public GreedyUnlimited(Function function) {
		this.function = function;
	}
	
	public int[] maximize(int nrElements, int maxNr) {
		Set<Integer> selected = new HashSet<Integer>();
		double curScore = 0.0;
		for (int i = 0; i < maxNr; i++) {
			List<Integer> candidates = new ArrayList<Integer>(nrElements);
			for (int j = 1; j <= nrElements; j++) {
				candidates.add(j);
			}
			candidates.removeAll(selected);
			
			double[] gains = new double[candidates.size()];
			int j = 0;
			for (Integer e : candidates) {
				int[] Stest = new int[selected.size() + 1];
				int k = 0;
				for (Integer e2 : selected) {
					Stest[k] = e2;
					k++;
				}
				Stest[k] = e; // add candidate
				
				gains[j] = function.eval(Stest) - curScore;
				
				j++;
			}
			
			// find maximum
			double maxGain = Double.NEGATIVE_INFINITY;
			Integer maxEl = -1;
			j = 0;
			for (Integer e : candidates) {
				if (gains[j] >= maxGain) {
					maxGain = gains[j];
					maxEl = e;
				}
				j++;
			}
			if (maxGain <= 0) {
				break;
			}
			
			selected.add(maxEl);
			curScore = curScore + maxGain;
		}
		
		int[] S = new int[selected.size()];
		int i = 0;
		for (Integer e : selected) {
			S[i] = e;
			i++;
		}
		return S;
	}
	
	// /////
	public int[] maximizeadv(int nrElements, int maxNr) {
		Set<Integer> selected = new HashSet<Integer>();
		double curScore = 0.0;
		for (int i = 0; i < maxNr; i++) {
			List<Integer> candidates = new ArrayList<Integer>(nrElements);
			for (int j = 1; j <= nrElements; j++) {
				candidates.add(j);
			}
			candidates.removeAll(selected);
			
			int[] candidatesInt = new int[candidates.size()];
			int j = 0;
			for (Integer e : candidates) {
				candidatesInt[j] = e;
				j++;
			}
			
			int[] selectedInt = new int[selected.size()];
			j = 0;
			for (Integer e : selected) {
				selectedInt[j] = e;
				j++;
			}
			
			double[] scores = function.eval(selectedInt, candidatesInt);
			
			// find maximum
			double maxGain = Double.NEGATIVE_INFINITY;
			Integer maxEl = -1;
			j = 0;
			for (Integer e : candidates) {
				if (scores[j] >= maxGain) {
					maxGain = scores[j];
					maxEl = e;
				}
				j++;
			}
			if (maxEl == -1) {
				throw new RuntimeException("No gain was larger than -inf.");
			}
			maxGain -= curScore;
			if (maxGain <= 0) {
				break;
			}
			
			selected.add(maxEl);
			curScore = curScore + maxGain;
		}
		
		int[] S = new int[selected.size()];
		int i = 0;
		for (Integer e : selected) {
			S[i] = e;
			i++;
		}
		return S;
	}
}
