public class HingeLoss implements Function {
	
	private double fct(int[] S) {
		double val = -10.0 + (double) S.length;
		val *= val;
		return -val;
	}
	
	/*
	 * private double fct(int[] S) { double val = 10.0 - (double) S.length; if (val > 0.0) val = 0.0; return val; }
	 */
	
	@Override
	public double eval(int[] S) {
		if (S == null) {
			return fct(new int[0]);
		}
		
		return fct(S);
	}
	
	@Override
	public double eval(int S) {
		return fct(new int[] { S });
	}
	
	@Override
	public double[] eval(int[] B, int[] cand) {
		if (cand == null) {
			return null;
		}
		int nrCandidates = cand.length;
		double[] values = new double[nrCandidates];
		
		int[] tmp = new int[B.length + 1];
		for (int k = 0; k < B.length; k++) {
			tmp[k] = B[k];
		}
		tmp[tmp.length - 1] = cand[0];
		
		double val = fct(tmp);
		
		for (int i = 0; i < nrCandidates; i++) {
			values[i] = val;
		}
		
		return values;
	}
	
}
