import static jcuda.driver.JCudaDriver.cuCtxCreate;
import static jcuda.driver.JCudaDriver.cuDeviceGet;
import static jcuda.driver.JCudaDriver.cuInit;
import static jcuda.driver.JCudaDriver.cuCtxPopCurrent;
import jcuda.driver.CUcontext;
import jcuda.driver.CUdevice;
import jcuda.driver.JCudaDriver;

public class InitCuda {
	private final CUcontext context;
	
	public CUcontext getContext() {
		return this.context;
	}
	
	public InitCuda() {
		// ---- // Enable exceptions and omit all subsequent error checks
		JCudaDriver.setExceptionsEnabled(true);
		// Initialize the driver and create a context for the first device.
		// int errorFlag = cudaSetDeviceFlags(cudaDeviceMapHost);
		// System.out.println("Error when setting flag: " + errorFlag);
		cuInit(0);
		CUdevice device = new CUdevice();
		cuDeviceGet(device, 0);
		// errorFlag = cudaSetDeviceFlags(cudaDeviceMapHost);
		// System.out.println("Error when setting flag: " + errorFlag);
		CUcontext context = new CUcontext();
		// cuCtxCreate(context, cudaDeviceMapHost, device); // Check if the device supports mapped host memory
		cuCtxCreate(context, 0, device); // Check if the device supports mapped host memory
		// cudaDeviceProp deviceProperties = new cudaDeviceProp();
		// cudaGetDeviceProperties(deviceProperties, 0);
		// if (deviceProperties.canMapHostMemory == 0) {
		// System.err.println("This device can not map host memory");
		// System.err.println(deviceProperties.toFormattedString());
		// System.exit(-1);
		// }
		// System.out.println("PROPS: " + deviceProperties);
		// System.out.println("We can use mapped memory.");
		// Set the flag indicating that mapped memory will be used
		// cudaSetDeviceFlags(cudaDeviceMapHost);
		
		this.context = context;
		//System.out.println("ORIGINAL CONTEXT: " + context);
		
		cuCtxPopCurrent(context);
	}
	
}
