import java.io.Serializable;
import java.util.ArrayList;

public class Message implements Serializable {
	private static final long serialVersionUID = 1L;
	
	public static final int GET_WORK = 0;
	public static final int WAIT = 1; // no work available currently -> sleep a second
	public static final int WORK = 2; // work
	public static final int QUIT = 3; // quit work
	public static final int WORK_DONE = 4; // work done
	public static final int ADD_WORK = 5; // add work
	public static final int GET_GRADIENT = 6; // get gradient
	public static final int GRADIENT = 7; // gradient
	public static final int SET_WEIGHTS = 8;
	public static final int CLEAR_QUEUES = 9;
	public static final int IS_WORK_DONE = 10;
	public static final int WORK_STATUS = 11; // indicates whether work is done or not
	
	private final String id;
	private final int type;
	private Work work;
	private WorkResult workResult;
	private double[] weights;
	private ArrayList<Work> workList;
	private boolean workDone = false;
	
	public Message(String id, int type) {
		this.id = id;
		this.type = type;
	}
	
	public String getId() {
		return id;
	}
	
	public int getType() {
		return type;
	}
	
	public Work getWork() {
		return work;
	}
	
	public void setWork(Work work) {
		this.work = work;
	}
	
	public WorkResult getWorkResult() {
		return workResult;
	}
	
	public void setWorkResult(WorkResult workResult) {
		this.workResult = workResult;
	}
	
	public double[] getWeights() {
		return weights;
	}
	
	public void setWeights(double[] weights) {
		this.weights = weights;
	}
	
	public ArrayList<Work> getWorkList() {
		return workList;
	}
	
	public void setWorkList(ArrayList<Work> workList) {
		this.workList = workList;
	}
	
	public boolean isWorkDone() {
		return workDone;
	}
	
	public void setWorkDone(boolean workDone) {
		this.workDone = workDone;
	}
	
}
