import java.util.HashSet;

public class ModUpperB implements Function {
	
	private final Function f;
	private final double[] vecj;
	private final int[] B;
	
	public ModUpperB(Function f, int[] B, double[] vecj) {
		this.f = f;
		this.vecj = vecj;
		this.B = B;
	}
	
	// For octave compatibility
	public double eval(int St) {
		int[] S = new int[1];
		S[0] = St;
		return eval(S);
	}
	
	public double eval(int[] A) {
		double val = 0.0;
		
		// System.out.println("MOD UPPERA");
		
		// Arrays.sort(A);
		// Arrays.sort(B);
		
		// compute A minus B; B minus A
		HashSet<Integer> Aset = new HashSet<Integer>();
		if (A != null) {
			for (Integer i : A) {
				Aset.add(i);
			}
		}
		HashSet<Integer> Bset = new HashSet<Integer>();
		if (B != null) {
			for (Integer i : B) {
				Bset.add(i);
			}
		}
		HashSet<Integer> AminusB = ((HashSet<Integer>) Aset.clone());
		AminusB.removeAll(Bset);
		HashSet<Integer> BminusA = ((HashSet<Integer>) Bset.clone());
		BminusA.removeAll(Aset);
		
		// AminusB and BminusA are correct
		for (Integer i : BminusA) {
			val -= vecj[i - 1];
		}
		
		double currset = f.eval(B);
		for (Integer j : AminusB) {
			
			int[] Bplusj = new int[Bset.size() + 1];
			int k = 0;
			for (Integer l : Bset) {
				if (l == j)
					continue;
				Bplusj[k] = l;
				k++;
			}
			Bplusj[Bset.size()] = j;
			val += f.eval(Bplusj) - currset;
		}
		
		return val;
	}
	
	@Override
	public double[] eval(int[] B, int[] cand) {
		// TODO Auto-generated method stub
		return null;
	}
	
}
