import static org.junit.Assert.assertEquals;

import java.util.Random;

import org.junit.Test;

public class OneMinusRougeTest {
	
	@Test
	public void test() {
		int nrSummaries = 400;
		int nrWords = 1000;
		int nrImages = 100;
		int summaryLength = 10;
		
		// create summaries, bow and bowSummaries
		Random rg = new Random(12345);
		int[][] summaries = UtilsTest.generateSummaries(nrSummaries, summaryLength, nrImages, rg);
		double[][] bow = UtilsTest.generateBOW(nrImages, nrWords, rg);
		double[][] bowSummaries = UtilsTest.computeBOWofSummaries(summaries, bow);
		
		// create rouge loss
		OneMinusRouge omr = new OneMinusRouge(summaries, bow, bowSummaries);
		
		// time
		int[] S = new int[1];
		int[] cand = new int[50];
		for (int j = 0; j < S.length; j++) {
			int idx = (rg.nextInt() % nrImages);
			if (idx < 0)
				idx = -idx;
			S[j] = idx + 1;
		}
		for (int j = 0; j < cand.length; j++) {
			cand[j] = j + 1;
		}
		double val1 = omr.evalClassic(S);
		System.out.println("Val classic: " + val1);
		
		double val2 = omr.eval(S);
		System.out.println("Val fast: " + val2);
		
		// Output: 0.1055835265704429
		assertEquals(0.8998729070505165, val1, 1e-6);
		assertEquals(0.8998729070505165, val2, 1e-6);
	}
	
}
