import java.util.Random;


public class TimeFunctions {
	
	private static final int nrElements = 100;
	private static final int nrRuns = 100;

	public static void main(String[] args) {
		System.out.println("Timing functions...");
		
		// generate similarity functions
		double[][] sim = new double[nrElements][nrElements];
		Random randomGenerator = new Random(12345);
		for (int i = 0; i < nrElements; i++) {
			for (int j = 0; j < nrElements; j++) {
				sim[i][j] = randomGenerator.nextDouble();
			}
		}
		
		long tstart = 0;
		long tend = 1;
		
		// set of elements
		int[] S = new int[]{1,2,3,4,5,6,7,8,9,10};
		
		// Facility Location
		FacilityLocation FL = new FacilityLocation(sim);
		tstart = System.nanoTime();
		for (int t = 0; t < nrRuns; t++) {
			FL.eval(S);
		}
		tend = System.nanoTime();
		System.out.println(String.format("Factility Location: Average runtime: %.2f us ", (tend-tstart) / (nrRuns*100.0)));
	}

}
