function [ ] = analyze_vrouge_plot( randScores, humanScores )
%ANALYZE_VROUGE_PLOT Summary of this function goes here
%   Detailed explanation goes here

%% settings
bins = 0.0:0.02:1.0;
fbins = 0.0:0.005:1.0;

%% compute stats
meanHuman = mean(humanScores);
meanRand = mean(randScores);
stdHuman = std(humanScores);
stdRand = std(randScores);

% compute overlap as random summaries exceeding the worst human summary
th = min(humanScores);
overlap = sum(randScores > th) / length(randScores) * 100;

%% plot
cla
[a,b] = hist(randScores, bins);
a = a / sum(a) / (b(2) - b(1));
bh = bar(b,a, 'FaceColor', 'r');
alpha(get(bh,'children'),.1);
hold on;

[a,b] = hist(humanScores, bins);
a = a / sum(a) / (b(2) - b(1));
bh = bar(b,a);
alpha(get(bh,'children'),.1);
xlim([0,1]);
title(sprintf('Histogram after %d pruning steps (overlap = %2.2f %%)', i, overlap));

[a,b] = hist(humanScores, bins);
a = a / sum(a) / (b(2) - b(1));
bh = bar(b,a);
alpha(get(bh,'children'),.1);
xlim([0,1]);

%% show stats
% show mean
yl = ylim();
lh = line([meanRand, meanRand], yl);
set(lh, 'Color', 'r');
set(lh, 'LineWidth', 1.5);
hold on;

% show histogram
y = normpdf(fbins, meanRand, stdRand);
plot(fbins, y, 'r', 'LineWidth', 1.5);

% show mean
yl = ylim();
lh = line([meanHuman, meanHuman], yl);
set(lh, 'Color', 'b');
set(lh, 'LineWidth', 1.5);
hold on;

% show histogram
y = normpdf(fbins, meanHuman, stdHuman);
plot(fbins, y, 'b', 'LineWidth', 1.5);

end

