function [] = analyze_vrouge_table(thresholds, nrPruneTh, perPruneTh)
%% plots a table showing how many summaries must be pruned to achieve
%% a certain threshold

fid = 1;

fprintf(fid, '\\documentclass[a4paper]{article}\n\n\\usepackage{booktabs}\n\n\n');
fprintf(fid, '\\usepackage[top=1cm,bottom=1cm,left=1cm,right=1cm,landscape]{geometry}\n');
fprintf(fid, '\\begin{document}\n');

nrCols = length(thresholds) + 1;
fprintf(fid, '\\begin{table}\n');
fprintf(fid, '\\caption{Percentage of summaries to prune to achieve a certain overlap of the random and the human scores. In brackets, the number of summaries to prune is shown.}\n');
fprintf(fid, '\\begin{tabular}{');
for i = 1:nrCols,
	fprintf(fid, 'c');
end
fprintf(fid, '}\n');

% show head
fprintf(fid, '\\toprule\n');
fprintf(fid, ' & \\multicolumn{%d}{c}{Desired Overlap}\\\\ \\cmidrule{2-%d}\n', nrCols-1, nrCols);

% show thresholds
fprintf(fid, ' & ');
for i = 1:length(thresholds),
	fprintf(fid, '%2.2f \\%%', thresholds(i)*100);
	if i < length(thresholds),
		fprintf(fid, ' & ');
	end
end
fprintf(fid, '\\\\ \\midrule \n');

% show table content
for dataset = 1:14,
fprintf(fid, '\\textbf{DS %d} &', dataset);
  
  for i = 1:length(thresholds),
    fprintf(fid, ' %2.2f \\%% (%d) ', perPruneTh(dataset, i)*100, nrPruneTh(dataset,i));
    
    if i < length(thresholds),
      fprintf(fid, ' & ');
    end
  end
  fprintf(fid, '\\\\\n');
end
fprintf(fid, '\\bottomrule');

fprintf(fid, '\\end{tabular}\n');

fprintf(fid, '\\end{table}\n');

fprintf(fid, '\\end{document}\n');
end
