%% Learns the objective as discussed in the meeting on October, 1st

% Compares several different encoders.

% sensitivty to encoder threshold is large (should be in the range of 0.9)
% TODO: Try something like a kernel distance.

clc;
clear all;

%% settings
dataset = 10;
%nrVisualWordsRange = ceil(logspace(2,4,10));
nrVisualWordsRange = 1000:500:1000; %ceil(logspace(2,4,6));
lambda = 10; % regularizer
nrAverageScore = 1000;
nrAverage = 1;
nrImages = 100;
summaryLength = 10;
% encoderList = {'nn', 'stIP', 'stIPsum', 'stIPmax'};
encoderList = {'nn'};
encoderThreshold = 0.8;
normalizeBOW = 'l1';
clustering = 'random';

%% draw random summaries
rand('seed', 123456);
randomSummaries = randomSummary(nrImages, summaryLength, nrAverageScore);


%% load dataset
[imagesrgb, imagesgray] = get_images(dataset, false);

% [imagesrgb, imagesgray, imageshsv, imageslab] = get_images(dataset, false);

%%
% contrast = zeros(100,1);
% for img = 1:100,
%     fprintf(1, '.');
%     t = imagesgray(:,:,img);
%     contrast(img) = (max(t(:)) - min(t(:))) / (max(t(:)) + min(t(:)));
% end
% fprintf(1, '\n');
% 
% keyboard


%% compute pairwise sift feature matches
% nrMatches = zeros(100,100);
% for img1 = 12:100,
%     fprintf(1, '.');
%     [fa, da] = vl_phow(single(imagesgray(:,:,img1)));
%     for img2 = 1:100,
%         [fb, db] = vl_phow(single(imagesgray(:,:,img2)));
%         % [matches, scores] = vl_ubcmatch(da, db);
%         clear('b');
%         b = vl_alldist(single(da),single(db));
%         [~,e] = sort(b, 1, 'ascend');
%         clear('b');
%         b = vl_alldist(single(db),single(da));
%         [~,f] = sort(b, 1, 'ascend');
%         t = 0;
%         for k = 1:size(f,2),
%            
%         end
%         nrMatches(img1, img2) = sum(e(f) == f);
%         nrMatches(img1, img2)
%     end
% end
% fprintf(1, '\n');



%%
options =  struct();
options.clustering = 'given';
options.dataset = dataset;
%options.centers = centers;
options.normalizeBOW = 'maxActivation';
options.verbose = true;
options.normalizeFeatures = 'l1';
% options.buildPyramid = true;
<<<<<<< .mine
options.featureType = 'phow';
=======
options.featureType = 'colorSQ';
options.nrVisualWords = 5000;
if strcmp(options.clustering, 'given'),
    options.centers = rand(24, options.nrVisualWords, 'single');
    for k = 1:options.nrVisualWords
        options.centers(:,k) = options.centers(:,k) / norm(options.centers(:,k), 1);
    end
end
>>>>>>> .r10712

optionsEncoder = struct();
<<<<<<< .mine
optionsEncoder.encoder = 'nnSoft';
optionsEncoder.encoderThreshold = 1;
=======
optionsEncoder.encoder = 'nnSoftSum';
optionsEncoder.encoderThreshold = 0.5;
>>>>>>> .r10712
optionsEncoder.logSpaceScaling = false;
optionsEncoder.sigma = 0.1;
options.appendColorHistogram = false;

options.encoderOptions = optionsEncoder;
<<<<<<< .mine
bow = [];
i = 1;
nrWordsRange = logspace(2, 3, 5);
=======
[bow,~,~] = get_BOW4(imagesrgb, imagesgray, options);
%bow2 = get_BOW(dataset);
subplot(2,1,1);
imagesc(BOWsimilarity([bow]) - eye(100));
subplot(2,1,2);
imagesc(BOWsimilarity(applyTFIDF(bow, get_TFIDF(bow))) - eye(100));
>>>>>>> .r10712

%% precompute dictionary with standard colors
dictionary = zeros(24,16);
optionsHist = struct();
optionsHist.bins = [8,8,8];
optionsHist.histType = 'SQ';
% white
a = zeros(10,10,3); 
a(:,:,:) = 1; 
dictionary(:,1) = get_colorHistogramPatch(a, optionsHist);

% silver
a = zeros(10,10,3); 
a(:,:,:) = 0.75; 
dictionary(:,2) = get_colorHistogramPatch(a, optionsHist);

% gray
a = zeros(10,10,3); 
a(:,:,:) = 0.5; 
dictionary(:,3) = get_colorHistogramPatch(a, optionsHist);

% black
a = zeros(10,10,3); 
a(:,:,:) = 0; 
dictionary(:,4) = get_colorHistogramPatch(a, optionsHist);

% yellow
a = zeros(10,10,3); 
a(:,:,1) = 1; 
a(:,:,2) = 1; 
dictionary(:,5) = get_colorHistogramPatch(a, optionsHist);

% fuchsia
a = zeros(10,10,3); 
a(:,:,1) = 1; 
a(:,:,3) = 1; 
dictionary(:,6) = get_colorHistogramPatch(a, optionsHist);

% red
a = zeros(10,10,3); 
a(:,:,1) = 1; 
dictionary(:,7) = get_colorHistogramPatch(a, optionsHist);

% maroon
a = zeros(10,10,3); 
a(:,:,1) = 0.5; 
dictionary(:,8) = get_colorHistogramPatch(a, optionsHist);

% lime
a = zeros(10,10,3); 
a(:,:,2) = 1; 
dictionary(:,9) = get_colorHistogramPatch(a, optionsHist);

% olive
a = zeros(10,10,3); 
a(:,:,1) = 0.5; 
a(:,:,2) = 0.5;
dictionary(:,10) = get_colorHistogramPatch(a, optionsHist);

% green
a = zeros(10,10,3); 
a(:,:,2) = 0.5; 
dictionary(:,11) = get_colorHistogramPatch(a, optionsHist);

% purple
a = zeros(10,10,3); 
a(:,:,1) = 0.5; 
a(:,:,3) = 0.5;
dictionary(:,12) = get_colorHistogramPatch(a, optionsHist);

% aqua
a = zeros(10,10,3); 
a(:,:,2) = 1; 
a(:,:,3) = 1;
dictionary(:,13) = get_colorHistogramPatch(a, optionsHist);

% teal
a = zeros(10,10,3); 
a(:,:,2) = 0.5; 
a(:,:,3) = 0.5;
dictionary(:,14) = get_colorHistogramPatch(a, optionsHist);

% blue
a = zeros(10,10,3); 
a(:,:,3) = 1;
dictionary(:,15) = get_colorHistogramPatch(a, optionsHist);

% navy
a = zeros(10,10,3); 
a(:,:,3) = 0.5;
dictionary(:,16) = get_colorHistogramPatch(a, optionsHist);


%% normalize
for i = 1:size(dictionary,2),
    dictionary(:,i) = dictionary(:,i) / norm(dictionary(:,i), 1);
end

i = 1;
sim = zeros(100);
for nrWords = nrWordsRange,
    i
    nrWords
    options.nrVisualWords = nrWords;
    
    % extract dictionary from other image sets
%     dictionary = [];
%     for ds = 1:5,
%         [imagesrgb2,imagesgray2] = get_images(ds, false);
%         [~,~,tdictionary,~] = get_BOW4(imagesrgb2, imagesgray2, options);
%         dictionary = horzcat(dictionary, tdictionary);
%     end
%     
%     options.clustering = 'given';
%     options.centers = dictionary;
%     options.encoderOptions.encoderThreshold = 1;
    [tbow,~,dictionary,~] = get_BOW4(imagesrgb, imagesgray, options);
    bow = [bow; 2^(-(length(nrWordsRange)-i))*tbow];
    i = i + 1;
    sim = sim + BOWsimilarity(bow) - eye(100);
end

% % sim = zeros(100);
% % imageStr = {'imagesrgb', 'imageshsv', 'imageslab'};
% % for i = 1:length(imageStr),
% %     eval(sprintf('imgs = %s;', imageStr{i}));
% %     for img = 1:100,
% %         h = fspecial('gaussian', 2, 4);
% %         %imgs(:,:,:,img) = imfilter(imageshsv(:,:,:,img),h);
% %     end
% %     imgs(imgs > 1) = 1;
% %     imgs(imgs < 0) = 0;
% % 
% %     [bow,~,~] = get_BOW4(imgs, imagesgray, options);
% %     sim = sim + BOWsimilarity(bow) - eye(100);
% % end
% % sim = sim / 3;
% d = zeros(9, 100);
% imgs = imageshsv;
% for img = 1:100,
%     c1 = imgs(:,:,1,img);
%     c1 = c1(:);
%     c2 = imgs(:,:,2,img);
%     c2 = c2(:);
%     c3 = imgs(:,:,3,img);
%     c3 = c3(:);
%     dl = zeros(size(d,1),1);
%     dl(1) = mean(c1);
%     dl(2) = mean(c2);
%     dl(3) = mean(c3);
%     dl(4) = std(c1);
%     dl(5) = std(c2);
%     dl(6) = std(c3);
% %     dl(7) = skewness(c1);
% %     dl(8) = skewness(c2);
% %     dl(9) = skewness(c3);
%     d(:,img) = dl / norm(dl,2);
% end
<<<<<<< .mine
% sim = d'*d;
imagesc(sim);
=======
% sim = sim / 3;
>>>>>>> .r10712

% return
% d = zeros(9, 100);
% imgs = imageslab;
% for img = 1:100,
%     c1 = imgs(:,:,1,img);
%     c1 = c1(:);
%     c2 = imgs(:,:,2,img);
%     c2 = c2(:);
%     c3 = imgs(:,:,3,img);
%     c3 = c3(:);
%     dl = zeros(size(d,1),1);
%     dl(1) = mean(c1);
%     dl(2) = mean(c2);
%     dl(3) = mean(c3);
%     dl(4) = std(c1);
%     dl(5) = std(c2);
%     dl(6) = std(c3);
% %     dl(7) = skewness(c1);
% %     dl(8) = skewness(c2);
% %     dl(9) = skewness(c3);
%     d(:,img) = dl / norm(dl,2);
% end
% sim = d'*d;
% imagesc(BOWsimilarity(d, 'l1exp'));
% return

%% score
%bow = rand(size(bow));
summaries = pruneSummaries(dataset, 100);
bowTFIDF = bow; % applyTFIDF(bow, get_TFIDF(bow));
summariesAsBOW = computeBOWSummary(summaries, bowTFIDF);

% Compute scores
options.bow = bow; %applyTFIDF(bow, get_TFIDF(bow));
options.summariesAsBow = summariesAsBOW;
[randScore, randScores] = summaryEvaluation(randomSummaries, summaries, 'rouge', options);
[sumScore, scores] = summaryEvaluation(summaries, summaries, 'rouge', options);

scoresStr = sprintf('Human summaries/Random summaries: %f (+-%f)/%f (+-%f) (overlap: %f; ratio: %f)\n', sumScore, std(scores), randScore, std(randScores), computeGaussianOverlap(mean(scores), mean(randScores), std(scores), std(randScores)), mean(scores) / mean(randScores));
fprintf(1, '**** %s\n', scoresStr);

% random bow
fprintf(1, '!!! Replacing bow with random words.\n');
counts = sum(bow > 0, 1);
bowRandom = bow;
for img = 1:100,
    t = randperm(size(bow,1));
    bowRandom(t(1:counts(img)), img) = 1;
    bowRandom(:,img) = bowRandom(:,img) / sum(bowRandom(:,img));
end
[summaries, nrSummaries] = load_summaries(dataset);
summariesAsBOWRandom = computeBOWSummary(summaries, bowRandom);

% Compute scores
options.bow = bowRandom;
options.summariesAsBow = summariesAsBOWRandom;
[randScore, randScores] = summaryEvaluation(randomSummaries, summaries, 'rouge', options);
[sumScore, scores] = summaryEvaluation(summaries, summaries, 'rouge', options);

scoresStr = sprintf('Human summaries/Random summaries: %f (+-%f)/%f (+-%f) (overlap: %f; ratio: %f)\n', sumScore, std(scores), randScore, std(randScores), computeGaussianOverlap(mean(scores), mean(randScores), std(scores), std(randScores)), mean(scores) / mean(randScores));
fprintf(1, '**** %s\n', scoresStr);
return

%% check words
bowB = bow;
toRemove = [];
for i = 1:size(bow,1),
    bowT = bow(i,:);
    summariesAsBOW = computeBOWSummary(summaries, bowT);

    % Compute scores
    options = struct();
    options.bow = bowT; %applyTFIDF(bow, get_TFIDF(bow));
    options.summariesAsBow = summariesAsBOW;
    [randScore, randScores] = summaryEvaluation(randomSummaries, summaries, 'rouge', options);
    [sumScore, scores] = summaryEvaluation(summaries, summaries, 'rouge', options);

    ratio = mean(scores) / mean(randScores);
    overlap = computeGaussianOverlap(mean(scores), mean(randScores), std(scores), std(randScores));
    scoresStr = sprintf('Human summaries/Random summaries: %f (+-%f)/%f (+-%f) (overlap: %f; ratio: %f)\n', sumScore, std(scores), randScore, std(randScores), overlap,  ratio);
    fprintf(1, '[%4d] %s\n', i, scoresStr);
    
    if overlap > 0.90 || ratio < 1,
        toRemove(end+1) = i;
    end
end
return

%% load summaries and compute scores
[summaries, nrSummaries] = load_summaries(dataset);

resultsHuman = zeros(length(nrVisualWordsRange), nrAverage, length(encoderList));
resultsRandom = zeros(length(nrVisualWordsRange), nrAverage, length(encoderList));
for sigma = 1,
for nvw = 1:length(nrVisualWordsRange), % nrVisualWordsRange,
    nrVisualWords = nrVisualWordsRange(nvw);
    for round = 1:nrAverage,
        for enc = 1:length(encoderList),
            % for reproducability:
            rand('seed', 123456);
            %rng(123456);
            
            encoder = encoderList{enc};
            
            fprintf(1, '[%5d/%2d] encoder: %s\n', nrVisualWords, round, encoder);
            
            %% get codebook
%             if round == 1,
%                 options =  struct();
%                 options.normalizeBOW = normalizeBOW;
%                 options.encoder = encoder;
%                 options.encoderThreshold = encoderThreshold;
%                 options.clustering = clustering;
%                 [BOW,FDESC,centers] = get_BOW4(imagescolor, images, nrVisualWords, 'phow', encoder, options);
%             else
          bowF = [];
          %while size(bowF,1) < 1000,
                options =  struct();
                options.clustering = 'random';
                options.dataset = dataset;
                %options.centers = centers;
                options.normalizeBOW = normalizeBOW;
                options.verbose = true;
                options.normalizeFeatures = 'l1';
                % options.buildPyramid = true;
                options.featureType = 'dsift';
                options.nrVisualWords = 1000;
                
                optionsEncoder = struct();
                optionsEncoder.encoder = encoder;
                optionsEncoder.encoderThreshold = encoderThreshold;
                optionsEncoder.logSpaceScaling = false;
                optionsEncoder.sigma = sigma;
                
                
                options.encoderOptions = optionsEncoder;
                [bowSIFT,~,~] = get_BOW4(imagesrgb, imagesgray, options);
                
                %%
                options =  struct();
                options.clustering = 'random';
                options.dataset = dataset;
                %options.centers = centers;
                options.normalizeBOW = normalizeBOW;
                options.verbose = true;
                options.normalizeFeatures = 'l1';
                % options.buildPyramid = true;
                options.featureType = 'colorSQ';
                options.nrVisualWords = 500;
                
                optionsEncoder = struct();
                optionsEncoder.encoder = 'nnEMD';
                optionsEncoder.encoderThreshold = encoderThreshold;
                optionsEncoder.logSpaceScaling = false;
                optionsEncoder.sigma = sigma;
                
                
                options.encoderOptions = optionsEncoder;
                [bowColorRGB,~,~] = get_BOW4(imagesrgb, imagesgray, options);
                %%
                [bowColorHSV,~,~] = get_BOW4(imageshsv, imagesgray, options);
                [bowColorLAB,~,~] = get_BOW4(imageslab, imagesgray, options);
                %%
                
                options =  struct();
                options.clustering = 'kmeans';
                options.dataset = dataset;
                %options.centers = centers;
                options.normalizeBOW = normalizeBOW;
                options.verbose = true;
                options.normalizeFeatures = 'l1';
                % options.buildPyramid = true;
                options.featureType = 'colorHistogram';
                options.nrVisualWords = 1000;
                
                optionsEncoder = struct();
                optionsEncoder.encoder = 'nn';
                optionsEncoder.encoderThreshold = encoderThreshold;
                optionsEncoder.logSpaceScaling = false;
                optionsEncoder.sigma = sigma;
                options.encoderOptions = optionsEncoder;
                
                [bowColorHistogramRGB,~,~] = get_BOW4(imagesrgb, imagesgray, options);
                [bowColorHistogramHSV,~,~] = get_BOW4(imageshsv, imagesgray, options);
                [bowColorHistogramLAB,~,~] = get_BOW4(imageslab, imagesgray, options);
                %%
                
                save(sprintf('%s/precomp_ds_%d.mat', getPreDir(), dataset), 'bowSIFT', 'bowColorHSV', 'bowColorLAB', 'bowColorRGB', 'bowColorHistogramHSV', 'bowColorHistogramLAB', 'bowColorHistogramRGB');
                
                keyboard
                
                
                % check results
                
                %%
%                 t1 = sum(computeBOWSummary(summaries, bow), 1);
%                 t2 = sum(computeBOWSummary(randomSummaries, bow), 1);
%                 t = abs((t1-t2)./min(t1,t2));
%                 keep = logical(t > 1.5);
%                 bowF = vertcat(bowF, bow(keep, :));
%                 sum(keep)
%           end
%           bow = bowF;
%           keyboard
            
            %% compute and apply tfidf
            bow = applyTFIDF(bowOrig, get_TFIDF(bow));

            %% compute bag-of-words of humand and random summaries
            summariesAsBOW = computeBOWSummary(summaries, bow);

            %% Compute scores
            options.bow = bow;
            options.summariesAsBow = summariesAsBOW;
            [randScore, randScores] = summaryEvaluation(randomSummaries, summaries, 'rouge', options);
            [sumScore, scores] = summaryEvaluation(summaries, summaries, 'rouge', options);

            scoresStr = sprintf('Human summaries/Random summaries: %f (+-%f)/%f (+-%f) (overlap: %f; ratio: %f)\n', sumScore, std(scores), randScore, std(randScores), computeGaussianOverlap(mean(scores), mean(randScores), std(scores), std(randScores)), mean(scores) / mean(randScores));
            fprintf(1, '**** %f: %s\n', sigma, scoresStr);
            resultsHuman(nvw, round, enc) = computeGaussianOverlap(mean(scores), mean(randScores), std(scores), std(randScores));

            [selected, score, gains] = greedySummary(@(x) summaryEvaluation(x, summaries, 'rouge', options))
            montage(imagesrgb, 'Size', [1,10], 'Indices', selected);
    
            pause(0.1);
        end
    end
end
end
save('results/encoderComparison.mat');

%% plot results
tmp = mean(resultsRandom, 2);
tmp = squeeze(tmp);
tmp2 = mean(resultsHuman, 2);
tmp2 = squeeze(tmp2);
tmp2