#!/usr/bin/python

import os.path
from PIL import Image

oldImagesPath = "/clusterFS/home/user/stschia/ECCV2014/Data/large/"
newImagesPath = "/srv/stschia/tmp/original_cropped/"

print "Creating HTML to compare old and new images"

destSize = (200,200)

f = open("imageComparsion.html", "w")
f.write("<html>")
f.write("<body>")

for ds in range(1,14):
	print ">> Processing dataset %d...\n" % (ds)
	f.write("<h1>Dataset %d</h1>\n" % ds)
	
	f.write("<table>")
	for img in range(1,101):
		print "* Extracting info of image %d" % (img)
		
		directory = os.path.join("./images", "set%d" % (ds))
		if not os.path.exists(directory):
			os.makedirs(directory)
		
		imageId = img 
		
		image_file = os.path.join(oldImagesPath, "set%d" % (ds), "%d.jpg" % (imageId))
		img = Image.open(image_file)
		width, height = img.size
		img = img.resize(destSize, Image.BICUBIC)
		img.save(os.path.join(directory, "%d_current.jpg" % (imageId)))
		
		image_file = os.path.join(newImagesPath, "set%d" % (ds), "%d.jpg" % (imageId))
		img = Image.open(image_file)
		newWidth, newHeight = img.size
		img = img.resize(destSize, Image.BICUBIC)
		img.save(os.path.join(directory, "%d_new.jpg" % (imageId)))
		
		imagePathHTML = os.path.join("images/set%d" % (ds), "%d_current.jpg" % (imageId))
		imagePathNewHTML = os.path.join("images/set%d" % (ds), "%d_new.jpg" % (imageId))
		f.write("<tr>\n")
		f.write("<td>Image %d</td>" % imageId)
		f.write("<td style=\"padding: 5px\"><b>Currently used</b><br>Size: (%d,%d)<br><img src=\"%s\"></td>\n" % (width, height, imagePathHTML))
		f.write("<td><b>New</b><br>Size: (%d,%d)<br><img src=\"%s\"></td>\n" % (newWidth, newHeight, imagePathNewHTML))
		f.write("</tr>\n")
		
		print "  (%d,%d) => (%d,%d)" % (width, height, newWidth, newHeight)
		
	f.write("</table>")

f.write("</body>\n")
f.write("</html")
f.close();