function [ summariesAsBOW ] = computeBOWSummary( summaries, bow )
%COMPUTEBOWSUMMARY Computes the bag-of-words of summaries.
%   Detailed explanation goes here
%
%   Usage:
%
%      [ summariesAsBOW ] = computeBOWSummary( summaries, bow )

nrWords = size(bow, 1);
summariesAsBOW = NaN(size(summaries, 1), nrWords, 'single');
for k = 1:size(summaries, 1),
    summariesAsBOW(k, :) = sum(bow(:, summaries(k,:)), 2)';
end

end

