function [ overlap ] = computeOverlap( humanScores, randomScores, loss )
%COMPUTEOVERLAP Summary of this function goes here
%   computeOverlap( humanScores, randomScores, loss )

if nargin <= 2,
    loss = '';
end

if strcmp(loss, 'loss'),
    % compute overlap of loss (scores have the meaning of losses here)
    maxHumanLoss = max(humanScores);
    overlap = sum(randomScores < maxHumanLoss) / length(randomScores);
else
    % find random scores that exceed min human scores
    minHumanScore = min(humanScores);
    overlap = sum(randomScores > minHumanScore) / length(randomScores);
end
    
end

