function [ overlap ] = computeOverlapModified( humanScores, randomScores, loss )
%COMPUTEOVERLAP Summary of this function goes here
%   computeOverlap( humanScores, randomScores, loss )

if nargin <= 2,
    loss = '';
end

if strcmp(loss, 'loss'),
    % compute overlap of loss (scores have the meaning of losses here)
    maxHumanLossSoft = mean(humanScores + 2*std(humanScores));
    overlap = sum(randomScores < maxHumanLossSoft) / length(randomScores);
else
    % find random scores that exceed min human scores
    minHumanScoreSoft = mean(humanScores - 2*std(humanScores));
    overlap = sum(randomScores > minHumanScoreSoft) / length(randomScores);
end
    
end

