config = struct();

config.testDatasets = 1;
config.trainDatasets = 1;
config.resultsFilename = '/tmp/results.mat';
config.overlap = 0.1;
config.lossFunction = 'OneMinusRouge';
config.sortSummariesByScore = false;
config.lambda = 1e-2; % regularizer

config.optimizer = struct();
config.optimizer.verbose = true;
config.optimizer.logProgress = true;
config.optimizer.logEvery = 10; % log every 10th iteration
config.optimizer.SGDalgorithm = 'classic'; % classic, adagrad, gradientScaling
config.optimizer.etaInitial = 1e-1;
config.optimizer.inference = 'greedy';
config.optimizer.pruneThreshold = 0;
config.optimizer.loadWeights = false;
config.optimizer.project = 'positive'; % 'none', 'simplex', 'positive' 
config.optimizer.hingeWeight = 5e-4; % weight for hinge

config.inference.initializeWithGreedy = false;

cidx = 1;
config.components = struct();
config.components(cidx).type = 'FacilityLocation';
config.components(cidx).resource_type = 'similarity';
config.components(cidx).resource_desc = 'colorHistogram';
