function [ scoreFctStr ] = constructScoreFunction( weights, fctsStr, pruneThreshold )
%CONSTRUCTSCOREFUNCTION Summary of this function goes here
%   Detailed explanation goes here

if nargin < 3,
    pruneThreshold = 1e-3;
end

if isempty(weights) || all(weights < pruneThreshold),
    warning('You must supply at least one function.');
    scoreFctStr = '@(x) 0;';
    return
end

str = '@(x) ';
for f = 1:length(weights),
    if weights(f) < pruneThreshold
        continue;
    end
    str = strcat(str, sprintf(' + %f*%s{%d}(x)', weights(f), fctsStr, f));
end
scoreFctStr = str;


end

