function [] = convertData(predir)

if nargin < 1,
    predir = getPreDir();
    predir = fullfile(predir, 'resources/similarity');
end

d = dir(predir);
d = d(3:end);
for i = 1:length(d),
    if d(i).isdir,
        fprintf(1, 'Recursive call to %s.\n', d(i).name);
        convertData(fullfile(predir, d(i).name));
    else
        if strfind(d(i).name, '.mat'),
            fprintf(1, 'Coverting %s...\n', d(i).name);
            filename = fullfile(predir, d(i).name);
            load(filename, 'sim')
            
            % write to file
            filenameNew = strrep(filename, '.mat', '.dat');
            fh = fopen(filenameNew, 'w');
            fwrite(fh, sim / 100.0, 'float');
            fclose(fh);
            
            % singleton scores for SumCoverage
            scores = sum(sim, 1) / sum(sim(:));
            mkdir(fullfile(predir, 'sumScores'));
            filename = fullfile(predir, 'sumScores', d(i).name);
            filenameNew = strrep(filename, '.mat', '.dat');
            fh = fopen(filenameNew, 'w');
            fprintf(fh, '%f ', scores);
            fclose(fh);
        end
    end
end

end