function [  ] = convertImages(  )
%CONVERTIMAGES Converts images.
%   Creates .mat files of the images in rgb, hsv and gray color space (too
%   save the time for convertig them in each run). Resulting images are
%   stored in '../Data/setX/images.mat'. 

for dataset = 1:14, % cycle through datasets
    fprintf(1, 'Converting images in dataset %d/%d...\n', dataset, 14);
    suffix = 'jpg';
    dimx = 300;
    dimy = 300;

    %% Find images
    % direc = sprintf('%s/Data/set%d', '/atm/ente/home/rkiyer/Desktop/Rishabh-svn/Image_Summarization/', dataset);
    direc = sprintf('%s/../Data/larger/set%d', getPreDir(), dataset);
    files = dir(sprintf('%s/*.jpg', direc));
    if isempty(files),
        files = dir(sprintf('%s/*.JPG', direc));
        suffix = 'JPG';
    end
    if isempty(files),
        error('No files found in "%s".\n', direc);
    end
    
    %% Load images and convert them
    nrImages = length(files);
    imagesrgb = NaN(dimx,dimy,3,nrImages,'single');
    imageshsv = NaN(dimx,dimy,3,nrImages,'single');
    imagesgray = NaN(dimx,dimy,nrImages,'single');
    imageslab = NaN(dimx,dimy,3,nrImages,'single');
    % compute transformation rgb -> cie
    C = makecform('srgb2lab');
    for i = 1:nrImages,
        filename = sprintf('%s/%d.%s', direc, i, suffix);
        imagecurr = imread(filename);
        imagesrgb(:,:,:,i) = single(imresize(imagecurr, [dimx dimy])) / 255;
        imageshsv(:,:,:,i) = single(rgb2hsv(imagesrgb(:,:,:,i)));
        imagesgray(:,:,i) = single(rgb2gray(imagesrgb(:,:,:,i)));
        imageslab(:,:,:,i) = single(applycform(double(imagesrgb(:,:,:,i)),C));
    end
    if max(imagesrgb(:)) > 1,
        imagesrgb = imagesrgb / 255;
    end
    if max(imageshsv(:)) > 1,
        imageshsv = imageshsv / 255;
    end
    if max(imagesgray(:)) > 1,
        imagesgray = imagesgray / 255;
    end
%     t1 = imageslab(:,:,1,:);
%     t2 = imageslab(:,:,2,:);
%     t3 = imageslab(:,:,3,:);
%     imageslab(:,:,1,:) = imageslab(:,:,1,:) / max(t1(:));
%     imageslab(:,:,2,:) = (-min(t2(:)) + imageslab(:,:,2,:)) / (-min(t2(:)) + max(t2(:)));
%     imageslab(:,:,3,:) = (-min(t3(:)) + imageslab(:,:,3,:)) / (-min(t3(:)) + max(t3(:)));
    %% Save images
    fname = sprintf('%s/Data/set%d/images.mat', getPreDir(), dataset);
    mkdir(fileparts(fname));
    save(fname, 'imagesgray', 'imagesrgb', 'imageshsv', 'imageslab');
end

end
