%% Computes the fraction of saturated words at different pruning levels
clear all
clc

ds = 1;
th = 0.1;
    
% setup loss
summaries = pruneSummaries(ds, get_pruning_info(ds, th));

% setup evaluation
bowLoss = get_BOW_evaluation(ds);
summariesAsBOW = computeBOWSummary(summaries, bowLoss);

% setup evaluation
evaluationType = 'rouge';
options = struct();
options.bow = bowLoss;
options.summariesAsBow = summariesAsBOW; 

% plot
for s = 1:size(summaries, 1),
    clf
    summary = summaries(s,:);
       
    x = zeros(length(summary), 1);
    y = zeros(length(summary), 1);
    xminusone = 0;
    for i = 1:length(summary),
        x(i) = i; %xminusone + summaryEvaluation(summary(i), summaries, evaluationType, options); % singleton score
        xminusone = x(i);
        y(i) = summaryEvaluation(summary(1:i), summaries, evaluationType, options); 
    end
    plot(x,y, 'r');
    hold on;
    
    t = randperm(100);
    summary = t(1:length(summary));
    x = zeros(length(summary), 1);
    y = zeros(length(summary), 1);
    xminusone = 0;
    for i = 1:length(summary),
        x(i) = i; %xminusone + summaryEvaluation(summary(i), summaries, evaluationType, options); % singleton score
        xminusone = x(i);
        y(i) = summaryEvaluation(summary(1:i), summaries, evaluationType, options); 
    end
    plot(x,y, 'g');
    hold on;
    
    m = max(max(x), max(y));
    hold on
    %line([0,m], [0,m]);
    
    
    pause
end