#!/usr/bin/python

import os, sys, inspect
import numpy as np
import subprocess as sub
import time

# settings
template = "../configTemplate.txt"
configPath = "../configs"
resultPath = "results"

# load configTemplate
configFile = open(template)
configStr = configFile.read()
configFile.close()
configStrOriginal = configStr

setting1 = {'projection': "POSITIVE", 'inference': "SUBSUP", 'loss': "ONEMINUSROUGE"}
setting2 = {'projection': "SIMPLEX",  'inference': "SUBSUP", 'loss': "ONEMINUSROUGE"}

setting3 = {'projection': "POSITIVE", 'inference': "RANDOMIZEDGREEDY", 'loss': "COMPLEMENTROUGE"}
setting4 = {'projection': "SIMPLEX",  'inference': "RANDOMIZEDGREEDY", 'loss': "COMPLEMENTROUGE"}

setting5 = {'projection': "POSITIVE", 'inference': "GREEDY", 'loss': "SURROGATE"}
setting6 = {'projection': "SIMPLEX",  'inference': "GREEDY", 'loss': "SURROGATE"}

setting7 = {'projection': "POSITIVE", 'inference': "GREEDY", 'loss': "ONEMINUSROUGE"}
setting8 = {'projection': "SIMPLEX",  'inference': "GREEDY", 'loss': "ONEMINUSROUGE"}
settings = (setting1, setting2, setting3, setting4, setting5, setting6, setting7, setting8)
settings = (setting6, setting6)

testDatasetRange = range(14)
scenarioRange = ("CHEATING", "REAL")

for scenario in scenarioRange:
  for testDataset in testDatasetRange:
    for setting in settings:
          loss = setting["loss"]
          projection = setting["projection"]
          inference = setting["inference"]
                    
          configStr = configStrOriginal
          experimentPostscript = "ds_%d_projection_%s_inference_%s_loss_%s_scenario_%s.txt" % (testDataset+1, projection, inference, loss, scenario)
          configFilename = os.path.join(configPath, "config_%s" % (experimentPostscript))
          resultFilename = os.path.join(resultPath, "result_%s" % (experimentPostscript))
          
          replace = {};
          replace["projection"] = projection
          replace["inference"] = inference
          replace["loss"] = loss
          replace["testDataset"] = str(testDataset + 1)
          replace["scenario"] = scenario
          replace["resultFilename"] = resultFilename
          
          for r in replace:
          	  configStr = configStr.replace("$$" + r + "$$", replace[r])
          
          configFile = open(configFilename, "w")
          configFile.write(configStr)
          configFile.close()
	



