#!/usr/bin/python

import os, sys, inspect
import numpy as np
import subprocess as sub
from subprocess import call
import time
from BatchSystem import *
from os import listdir
from os.path import isfile, join
import socket

# settings
configPath = "../configs"

# settings to decide whether we run on dcluster or at SPSC
hostname = socket.gethostname()
if hostname == "dcluster":
	template = "../jobTemplate.zid"
	workPath = "/home/stschia/ECCV2014"
else:
	template = "../jobTemplate.spsc"
	workPath = "/clusterFS/home/user/stschia/ECCV2014"

configFile = open(template)
configStr = configFile.read()
configFile.close()
configStrOriginal = configStr

# perform cross-tuning
nrJobsThreshold = 150

onlyfiles = [ f for f in listdir(configPath) if isfile(join(configPath,f)) ]
print onlyfiles

for configFile in onlyfiles:
        configStr = configStrOriginal
	# check that not to many jobs are running
	if hostname == "dcluster":
		# count number of used CPUs
		while True:
			stream = os.popen("qselect -u stschia")
			t = len(stream.readlines())
			stream.close()
			if t == 0:
				break
			
			stream = os.popen("qselect -u stschia | xargs qstat -f | grep \"Resource_List.nodes\" | awk 'BEGIN {FS=\"=\"} {print $3}' | paste -sd+ | bc");
			t = stream.read()
			stream.close()
			try:
				n = int(t)
				print t
				if n < nrJobsThreshold:
					break
			except:
				print "Read invalid number."
				print t
			print "Waiting..."
			time.sleep(5)
	else:
		BatchSystem.waitForOpenSlot(nrJobsThreshold=nrJobsThreshold)
	
	replace = {};
	replace["jobname"] = "ECCV2014"
	replace["basePath"] = workPath
	replace["configFile"] = configFile
	if configFile.find("GREEDY") == -1:
		replace["slots"] = str(1)
	else:
		replace["slots"] = str(4)
	
	for r in replace:
		configStr = configStr.replace("$$" + r + "$$", replace[r])
		
	print configStr
	
	print("Running job...")
	startScript = configStr
	p = sub.Popen("qsub", stdin=sub.PIPE, stdout=sub.PIPE, stderr=sub.PIPE)
	out,err = p.communicate(startScript)
	print out
	print err




