function [bow, bowDescriptorStr] = get_BOW(dataset)

%% settings
nrVisualWords = 5000;

%% load images
% [imagesrgb, imagesgray, imageshsv, imageslab] = get_images(dataset, false);
% [imagesrgb, imagesgray] = get_images(dataset, false);

%% load summaries
summaries = load_summaries(dataset);

%% get codebook (SIFT)
options = struct();
options.clustering = 'random';
options.normalizeBOW = 'l1';
options.normalizeFeatuers = 'l1';
options.summaries = summaries;
options.dataset = dataset;
options.featureType = 'phow';
options.directory = sprintf('%s/precomputed/opponentSIFT/set%d', getPreDir(), dataset);
options.verbose = true;
options.nrVisualWords = nrVisualWords;

optionsEncoder = struct();
optionsEncoder.encoder = 'nn';
optionsEncoder.logSpaceScaling = false;
options.encoderOptions = optionsEncoder;

% filename for storing precomputed bow
fname = sprintf('%s/precomputed/%s', getPreDir(), get_BOWFilename(dataset, options));
if ~exist(fname, 'file'),
    error('Error. Bag-of-words file "%s" does not exist. Maybe you need to run "precompute_BOW.m".', fname);
end
load(fname);
bow1 = bow;
bow = bow1;
bow = single(bow);

% TODO: Put something useful here.
bowDescriptorStr = 'TODO'; 
    
%     %% get codebook (color)
%     nrVisualWords = 800;
%     options = struct();
%     options.clustering = 'random';
%     options.normalizeBOW = 'l1';
%     options.normalizeFeatuers = 'l1';
%     options.summaries = summaries;
%     options.dataset = dataset;
%     options.features = 'colorSQ';
%     options.verbose = true;
%     
%     optionsEncoder = struct();
%     optionsEncoder.encoder = 'nnEMD';
%     optionsEncoder.encoderThreshold = 0.80;
%     optionsEncoder.logSpaceScaling = false;
%     optionsEncoder.sigma = 0.007743;
%     options.encoderOptions = optionsEncoder;
%     % filename for storing precomputed bow
%     fname = sprintf('precomputed/bow_ds_%d_len_%d_enc_%s_clust_%s_norm_%s_feat_%s.mat', ...
%         dataset, nrVisualWords, options.encoderOptions.encoder, options.clustering, options.normalizeBOW, ...
%         options.features);
%     if exist(fname, 'file'),
%         warning('Loading precomputed bag-of-words.');
%         load(fname);
%         bow2 = bow;
%     else
%         [bow,FDESC] = get_BOW4(imagesrgb, imagesgray, nrVisualWords, options.features, options);
%         save(fname, 'bow', 'FDESC');
%         bow2 = bow;
%     end
%     
%     %% concatenate words
%     bow = vertcat(bow1, bow2);
%     for k = 1:size(bow,2),
%         nrm = norm(bow(:,k), 1);
%         if nrm < 1e-6,
%             nrm = 1;
%         end
%         bow(:,k) = bow(:,k) / nrm;
%     end

end
