function [gist, sim] = get_gist(dataset)
% GET_GIST Computes gist features.
%     The function computes gist features for dataset "dataset" and returns
%     these as "gist", 

fname = sprintf('%s/precomputed/gist_ds_%d.mat', getPreDir(), dataset);
if ~exist(fname, 'file'),
    error('GIST features file "%s" does not exist. Run the precomputation script..', fname);
end

load(fname);

%% Compute similarity matrix
nrImages = 100;
for i = 1:nrImages
    for j = 1:nrImages
        sim(i,j) = exp(-sum((gist(:,i)-gist(:,j)).^2)/2);
    end
end
end