clear all;
clc;

[images,imagesgray] = get_images(10, true);

%%
nrMatches = zeros(100);
options = {'Step', 8};
for img1 = 1:100,
    for img2 = 1:100,
        a = squeeze(imagesgray(:,:,img1));
        b = squeeze(imagesgray(:,:,img2));
        [fa, da] = vl_dsift(single(a), options{:});
        [fb, db] = vl_dsift(single(b), options{:});
        matches1 = vl_ubcmatch(da, db, 2.0);
        matches2 = vl_ubcmatch(db, da, 2.0);
        matches2 = [matches2(2,:); matches2(1,:)];
        nr = 0;
        for k = 1:size(matches1,2),
            if any(all(repmat(matches1(:,k), 1, size(matches2,2)) == matches2, 1)),
                nr = nr + 1;
            end
        end
        nrMatches(img1,img2) = nr;
        fprintf(1, 'Images: %d/%d => %d matches (out of %d possibles).\n', img1, img2, nrMatches(img1,img2), size(fb,2));
    end
end

%% pairwise encoding costs
encCosts = zeros(100);
options = {'Step', 4};
ub = 1e5;
for img1 = 1:100,
    for img2 = 1:100,
        a = squeeze(imagesgray(:,:,img1));
        b = squeeze(imagesgray(:,:,img2));
        [fa, da] = vl_dsift(single(a), options{:});
        [fb, db] = vl_dsift(single(b), options{:});
        da = single(da);
        db = single(db);
        tmp = vl_alldist(da,db);
        tmp(tmp > ub) = ub;
        tmp = sum(min(tmp, [], 1)) / (300*300);
        encCosts(img1,img2) = tmp;
        fprintf(1, 'Images: %d/%d => %f cost (out of %d possibles).\n', img1, img2, encCosts(img1,img2), size(fb,2));
    end
end