function [ summariesTrain, summariesTest ] = partitionSummaries( summaries, perTrain )
%PARTITIONSUMMARIES Summary of this function goes here
%   Detailed explanation goes here
%
%   function [ summariesTrain, summariesTest ] = partitionSummaries(
%   summaries, perTrain )

if perTrain < 0 || perTrain > 1,
    error('Percentage of training data must be between 0 and 1.');
end

nrSummaries = size(summaries, 1);
nrTrain = ceil(nrSummaries*perTrain);

% shuffle summaries
perm = randperm(nrSummaries);
summaries = summaries(perm,:);

summariesTrain = summaries(1:nrTrain,:);
summariesTest = summaries((nrTrain+1):end,:);


end

