#!/usr/bin/python

import sys 				# for command line arguments
import pylab as py
import numpy as np
import matplotlib.pyplot as plt
from matplotlib import rc
from scipy.optimize import curve_fit
import matplotlib.image as mpimg
import os
import scipy.io as sio
import random

# set path for tex on Mac
os.environ['PATH'] = os.environ['PATH'] + ':/opt/local/bin/latex'

for dataset in range(1,15):
	# plot axes and histograms
	fig = plt.figure(figsize=(10,10))
	fig.add_axes([0,0,1,1])
	plt.xlim((0,10))
	plt.ylim((0,10))
	plt.axis('off')

	# show images 
	idx = 1
	images = []
	for r in range(0,10):
	  for c in range(0,10):
	    fname = format('../../Data/set%d/%d.jpg' % (dataset, idx))
	    idx = idx + 1
	    img = mpimg.imread(fname)
	    images.append(img)
	    plt.imshow(img, extent=[c,(c+1),10-(r),10-(r+1)], interpolation='none')
	#fig.tight_layout(pad=0.0)
	fname = format("images/imagesDataset%d.jpg" % (dataset))
	plt.savefig(fname, dpi=150, format="jpg", bbox_inches='tight')
	
	# create random summary
	fig.clear()
	fig = plt.figure(figsize=(10,1))
	fig.add_axes([0,0,1,1])
	plt.xlim((0,10))
	plt.ylim((0,1))
	plt.axis('off')
	perm = range(0,100)
        random.shuffle(perm)
        for i in range(0,10):
        	plt.imshow(images[perm[i]], extent=[i,(i+1),1,0], interpolation='none')
	#fig.tight_layout(pad=0.0, w_pad=0.0)
	fname = format("images/imagesDatasetRandom%d.jpg" % (dataset))
	plt.savefig(fname, dpi=150, format="jpg", bbox_inches='tight')

