%% Collects all information together and prepares for plotting

clear all;
clc;

%% settings
datasets = 1:14;
nrRandom = 1000; % number of random summaries

%% setup
cd('..');
addpath('');
addpath('plotting');
addpath('external/sfo');

%% convert
for dataset = datasets,
    fprintf(1, '>> Processing dataset %d...\n', dataset);
    
    %% scores from learning accross datasets
    close all;
    fname = sprintf('../BatchSystem/results/results_dataset_%d.mat', dataset);
    load(fname, 'greedyMax', 'weights', 'allWeights', 'desc');

    %% barplot
    x = 1:length(weights);
    bar(x, weights ./ max(weights));
    set(gcf, 'PaperPosition', [0 0 8 3]);
    set(gcf, 'PaperSize', [8 3]);
    title('Component Weights (Maximum Normalized to 1)')
    xlabel('Component Indices')
    ylabel('Weight')

    fname = sprintf('plotting/images/dataset%d_weightVector.pdf', dataset);
    print('-dpdf', fname, '-r150');
    %saveas(gcf, fname);

    %% plot 10 % of most important weights
    close all;
    set(gcf, 'PaperPosition', [0 0 8, 8]);
    set(gcf, 'PaperSize', [8 8]);
    for i = 1:length(desc),
        desc(i) = strrep(desc(i), 'bow=bow1', 'super-pixel');
        desc(i) = strrep(desc(i), 'bow=bow2', 'super-pixel,TFIDF');
        desc(i) = strrep(desc(i), 'bow=bow3', 'color');
        desc(i) = strrep(desc(i), 'bow=bow4', 'color,TFIDF');
        desc(i) = strrep(desc(i), 'sim=bow1', 'super-pixel');
        desc(i) = strrep(desc(i), 'sim=bow2', 'super-pixel,TFIDF');
        desc(i) = strrep(desc(i), 'sim=bow3', 'color');
        desc(i) = strrep(desc(i), 'sim=bow4', 'color,TFIDF');
        desc(i) = strrep(desc(i), 'thresholded', 'th.');
    end
    [a,b] = sort(weights, 'descend');
    wIndices = b(1:ceil(length(weights)*0.1));
    wIndices = wIndices(end:-1:1);
    x = 1:length(wIndices);
    barh(x, weights(wIndices) / max(weights(wIndices)))
    set(gca, 'YTick', x, 'YTickLabel', desc(wIndices));
    title('Components with largest weight (10 % of all weights shown)')
    xlabel('Weight')

   fname = sprintf('plotting/images/dataset%d_weightVectorImportant.pdf', dataset);
   print('-dpdf', fname, '-r150');
   % saveas(gcf, fname);
end

cd('plotting');
