%% precomputes opponent sift
clear all
clc

preDir = getPreDir();

for dataset = 1:14,
    fprintf(1, '>> Processing dataset %d...\n', dataset);
    for img = 1:100,
        imageFilename = sprintf('%s/Data/set%d/%d.jpg', preDir, dataset, img);
        outputFilename = sprintf('%s/precomputed/opponentSIFT/set%d/%d.desc', preDir, dataset, img);
        
        targetDir = fileparts(outputFilename);
        if ~exist(targetDir, 'dir'),
            mkdir(targetDir);
        end
        
        execStr = sprintf('OpponentSIFT/x86_64-linux-gcc/colorDescriptor %s --detector densesampling --descriptor opponentsift --ds_spacing 4 --output %s', ...
            imageFilename, outputFilename);
        system(execStr);
    end
end