% Segments image from all datasets and stores the computed segmentations.

%% clean up
clear all;
clc;

%% setup VL-FEAT
setupVLFEAT

%% segment images
ratio = 1;
kernelsize = 5;
maxdist = 15;
for dataset = 12:14,
    fprintf(1, '[DS %2d] ', dataset);
    images = get_images(dataset, false);
    imagesSeg = zeros(size(images), 'single');
    imagesLabels = zeros(size(images,1), size(images,2), 100, 'single');
    for img = 1:100,
        fprintf(1, '.');
        [iseg, labels] = vl_quickseg(images(:,:,:,img), ratio, kernelsize, maxdist);
        imagesSeg(:,:,:,img) = iseg;
        imagesLabels(:,:,img) = labels;
        
        keyboard
    end
    fprintf(1, '\n');
    fname = sprintf('%s/Data/set%d/imagesSegmentation.mat', getPreDir(), dataset);
    save(fname, 'imagesSeg', 'imagesLabels');
end
