% Segments image from all datasets and stores the computed segmentations.

%% clean up
clear all;
clc;

%% setup VL-FEAT
setupVLFEAT

%% segment images
ratio = 1;
kernelsize = 5;
maxdist = ceil(1000 / 300 * 15);
for dataset = 12:14,
    fprintf(1, '[DS %2d] ', dataset);
    
    direc = sprintf('%s/../Data/larger/set%d', getPreDir(), dataset);
    suffix = 'jpg';
    filename = sprintf('%s/%d.%s', direc, 1, suffix);
    imagecurr = imread(filename);
    dimx = size(imagecurr, 1);
    dimy = size(imagecurr, 2);
    dimx
    dimy  
    
    imagesSeg = zeros(dimx, dimy, 100, 'single');
    imagesLabels = zeros(dimx, dimy, 100, 'single');
    for img = 1:100,
        filename = sprintf('%s/%d.%s', direc, 1, suffix);
        imagecurr = imread(filename);
        imagecurr = imresize(imagecurr, [1000 1000]) / 255;
        fprintf(1, '.');
        [iseg, labels] = vl_quickseg(imagecurr, ratio, kernelsize, maxdist);
        keyboard
        imagesSeg(:,:,:,img) = iseg;
        imagesLabels(:,:,img) = labels;
        
        
    end
    fprintf(1, '\n');
    fname = sprintf('%s/Data/set%d/imagesSegmentation.mat', getPreDir(), dataset);
    save(fname, 'imagesSeg', 'imagesLabels');
end
