function [] = precompute_BOW_extract_from_deep_model(dataset, image)
% Extracts features from a patch of an image and stores them to file.

%% >> settings >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
width = 100;
offset = 20;
%% << settings <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

%% >> set image path and load image info >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
imageFile = sprintf('../Data/large/set%d/%d.jpg', dataset, image);
if ~exist(imageFile, 'file'),
    error('File ''%s'' does not exist.', imageFile);
end

tmp = imread(imageFile);
xmax = size(tmp, 1);
ymax = size(tmp, 2);
clear('tmp');
%% << image info <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
        
% path to features file
featuresFile = sprintf('../precomputed/features/overfeat/set%d/temp/image_%d.mat', dataset, image);
if exist(featuresFile, 'file'),
    %fprintf(1, 'skip\n');
    %return
end
    
%% >> extract features >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
nmax = (xmax - width) / offset;
features = cell((nmax+1)*(nmax+1), 1);
idx = 1;
for nx = 0:nmax,
    for ny = 0:nmax,
        fprintf(1, '.');
        xwidth = 100;
        ywidth = 100;
        xoffset = nx*offset;
        yoffset = ny*offset;
        
        % prepare command string
        cmdString = sprintf('LD_LIBRARY_PATH=/usr/lib convert -crop %dx%d+%d+%d -resize 231x231 %s ppm:- | LD_LIBRARY_PATH=/usr/lib /clusterFS/home/user/stschia/ECCV2014/Codes/external/overfeat/src/overfeat -p -f', xwidth, ywidth, xoffset, yoffset, imageFile);
        [a,b] = system(cmdString);
        tmp = strsplit(b, '\n');
        dimsStr = tmp{1};
        weightsStr = tmp{2};
        dims = str2num(dimsStr);
        weights = str2num(weightsStr);
        features{idx} = weights;
        idx = idx + 1;
    end
end
fprintf(1, '\n');
%% << extract features <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

% save features
direc = fileparts(featuresFile);
if ~exist(direc, 'dir'),
    mkdir(direc);
end
save(featuresFile, 'features');

end
