#!/usr/bin/python

import sys
import os
from subprocess import call
import os.path
from PIL import Image
import math

dataset = int(sys.argv[1])
image = int(sys.argv[2])

## >> settings >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
nrSteps = 10
overlap = 0.5
#width = 100
#offset = 20
## << settings <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

## >> set image path and load image info >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
imageFile = "../Data/larger/set%d/%d.jpg" % (dataset, image)
print imageFile
if  not os.path.exists(imageFile):
    error('File ''%s'' does not exist.', imageFile)

#tmp = imread(imageFile);
#xmax = size(tmp, 1);
#ymax = size(tmp, 2);
#clear('tmp');
img = Image.open(imageFile)
xmax, ymax = img.size

# compute width, i.e. xmax / nrSteps
width = int(math.floor(xmax/nrSteps))
offset = int(width * overlap)
print "Width %d / Offset %d" % (width, offset)
## << image info <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
        
## path to features file
featuresFile = "../precomputed/features/overfeat/set%d/temp/image_%d.mat" % (dataset, image)
print featuresFile
if os.path.exists(featuresFile):
     print "Skipping...."
     sys.exit("DONE")


## >> extract features >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
nmax = (xmax - width) / offset;
features = {}
idx = 1;
f = open(featuresFile, 'w');
for nx in range(nmax+1):
    for ny in range(nmax+1):
        print "."
        xwidth = width
        ywidth = width
        xoffset = nx*offset;
        yoffset = ny*offset;
        
        # prepare command string
        cmdString = "convert -crop %dx%d+%d+%d -resize 231x231 %s ppm:- | LD_LIBRARY_PATH=/usr/lib /clusterFS/home/user/stschia/ECCV2014/Codes/external/overfeat/src/overfeat -p -f " % (xwidth, ywidth, xoffset, yoffset, imageFile)
        a = os.popen(cmdString).read();
        print "Executing: %s" % (cmdString)
        #print "Read: %s" % (a)
        t = a.split('\n', 1)
        tmp = t[0];
        dimsStr = t[0];
        weightsStr = t[1];
        dims = map(int, dimsStr.strip().split(' '));
        weights = map(float, weightsStr.strip().split(' '));
        features[idx] = weights;
        idx = idx + 1;
        stri = "".join(["%f " % v for v in weights])
        f.write(stri)
        f.write("\n")
f.close()
## << extract features <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

