function [ w ] = projectOntoSimplex( v, z )
%PROJECTONTOSIMPLEX Summary of this function goes here
%   projectOntoSimplex( v, z )
%
%   http://www.cs.huji.ac.il/~shais/papers/DuchiShSi08.pdf

if nargin == 1,
    z = 1;
end

n = (1:length(v))';
mu = sort(v(:), 1, 'descend');
t = cumsum(mu);
tc = t;
t = mu - 1./n .* (t - z);
rho = find(t > 0, 1, 'last');

theta = 1/rho * (tc(rho) - z);

w = max(v - theta, 0);


end

