function [ summaries ] = randomSummary( baseSet, len, number )
%RANDOMSUMMARY Returns random summaries
%   The function
%
%     [ summaries ] = randomSummary( baseSet, len, number )
%
%   computes random summaries "summaries" by computing a random permutation
%   of size length(baseSet) (if baseSet is a vector) and returns a length "len" 
%   subset of the base set. If
%   the third parameter "number" is specified, a total of "number" random
%   summaries (each summary corresponds to a row) is returned.

if nargin < 3,
    number = 1;
end

if isscalar(baseSet),
    baseSet = 1:baseSet;
end

summaries = NaN(number, len);
for k = 1:number,
    rperm = randperm(length(baseSet));
    summaries(k,:) = baseSet(rperm(1:len));
end

end

