function [ val ] = rougeLoss( S, bow, summariesAsBow, ds )
%ROUGELOSS Summary of this function goes here
%   Detailed explanation goes here

%persistent refCounts;
%persistent normalization;
%
%if isempty(refCounts),
%    refCounts = sum(summariesAsBow, 1)';
%    refCounts(refCounts == 0) = 1;
%    normalization = sum(sum(bow, 2) ./ refCounts);
%end

%% old
% refCounts = sum(summariesAsBow, 1)';
% refCounts(refCounts == 0) = 1;
% normalization = sum(sum(bow, 2) ./ refCounts);
% 
% sumBow = sum(bow(:, S), 2);
% val = sum(sumBow ./ refCounts) / normalization;


%% new (old runtime: 8.22 s => 2.15 s with precomputation)
persistent refcounts;
persistent normalization;
persistent weights;

nrSummaries = size(summariesAsBow,1);

if isempty(refcounts),
    refcounts = cell(14,1);
    normalization = NaN(14,1);
    weights = cell(14,1);
end

if isempty(refcounts{ds}),
    t = mean(bow', 1) ./ mean(summariesAsBow, 1);
    t(isnan(t)) = 0;
    infidx = isinf(t);
    t(isinf(t)) = 0;
    t(infidx) = max(t)*10;
    weight = t / max(t);
    tbow = max(summariesAsBow, [], 2) * max(summariesAsBow, [], 1);
    weights{ds} = repmat(weight, nrSummaries, 1)';
    refcounts{ds} = tbow';
    
    normalization(ds) = sum(sum(repmat(weight, nrSummaries, 1)' .* tbow'));
end

sumBow = sum(bow(:, S), 2);

val = sum(sum(weights{ds} .* min(refcounts{ds}, repmat(sumBow, 1, nrSummaries))));
val = val / normalization(ds);

%%
%size(max(summariesAsBow,[],1))
%size(summariesAsBow) % (repmat(max(summariesAsBow,[],1),size(summariesAsBow,1),1)
%tbow = 10-summariesAsBow'; 
%size(tbow)
%val = sum(sum(min(tbow, repmat(sum(bow(:,S), 2), 1, size(tbow,2)))));

end

