function [ val, grad ] = rougeLossNew( S, bow, summariesAsBow, ds, weights, th)
%ROUGELOSS Summary of this function goes here
%   Detailed explanation goes here

nrSummaries = size(summariesAsBow, 1);
nrWords = size(summariesAsBow, 2);

% normalize BOW
for i = 1:100,
    bow(:,i) = bow(:,i) / norm(bow(:,i));
end

% compute thresholds
if nargin < 6,
    t = max(summariesAsBow, [], 1) / 3;
    %t = mean(summariesAsBow, 1);
    thresholds = repmat(t, nrSummaries, 1) - summariesAsBow;
    thresholds(thresholds < 0) = 0;
else
    thresholds = repmat(th(:)', nrSummaries, 1);
end
normalization = sum(sum(repmat(weights', nrSummaries, 1) .*thresholds));

val = zeros(size(S, 1), 1);

for i = 1:size(S,1),
    asBow = sum(bow(:,S(i,:)), 2)';
    val(i) = sum(sum(repmat(weights', nrSummaries, 1) .*min(thresholds, repmat(asBow, nrSummaries, 1)))) / normalization;
end

grad = zeros(size(thresholds));


%val = 1.0;


% %persistent refCounts;
% %persistent normalization;
% %
% %if isempty(refCounts),
% %    refCounts = sum(summariesAsBow, 1)';
% %    refCounts(refCounts == 0) = 1;
% %    normalization = sum(sum(bow, 2) ./ refCounts);
% %end
% 
% %refCounts = sum(summariesAsBow, 1)';
% %refCounts(refCounts == 0) = 1;
% %normalization = sum(sum(bow, 2) ./ refCounts);
% 
% %sumBow = sum(bow(:, S), 2);
% %val = sum(sumBow ./ refCounts) / normalization;
% 
% for i = 1:100,
%     bow(:,i) = bow(:,i) / norm(bow(:,i));
% end
% 
% %%
% nrSummaries = size(summariesAsBow, 1);
% nrWords = size(summariesAsBow, 2);
% %size(max(summariesAsBow,[],1))
% %size(summariesAsBow) % (repmat(max(summariesAsBow,[],1),size(summariesAsBow,1),1)
% % tbow = ((0.2 -summariesAsBow).*(summariesAsBow < 1e-6))'; 
% %tbow(tbow 
% %size(tbow)
% 
% %tmp = repmat(sumBow, 1, nrSummaries).*(summariesAsBow < 1e-6)';
% % val = sum(sum(min(0.2*ones(size(tmp)), tmp)));
% %val = sum(sum( tmp));
% 
% % tbow = max(summariesAsBow, [], 2) * max(summariesAsBow, [], 1);
% %tbow = mean(summariesAsBow, 2) * (1./mean(summariesAsBow, 1));
% %tbow = tbow';
% %tbow = (tbow .* (summariesAsBow < 1e-6))';
% %val = sum(sum(min(tbow, repmat(sumBow, 1, size(summariesAsBow,1)))));
% 
% randomSummaries = randomSummary(100, 10, 100);
% randomSummariesAsBow = computeBOWSummary(randomSummaries, bow);
% 
% sumBow = sum(bow(:, S), 2);
% t = mean(randomSummariesAsBow, 1) - mean(summariesAsBow, 1);
% limit = repmat(mean(randomSummariesAsBow, 1), nrSummaries, 1)';
% f = sum(mean(summariesAsBow, 1)) / sum(mean(randomSummariesAsBow, 1));
% t = mean(randomSummariesAsBow, 1) ./ mean(summariesAsBow, 1);
% t(isnan(t)) = 0;
% %t(t < 0) = 0;
% weight = t;
% tbow = max(summariesAsBow, [], 2) * max(summariesAsBow, [], 1);
% %val = sum(sum(repmat(weight, nrSummaries, 1)' .* min(tbow', 0.1*repmat(sumBow, 1, nrSummaries))));
% val = sum(sqrt(sum(repmat(weight, nrSummaries, 1)' .* (repmat(sumBow, 1, nrSummaries)))));



end

