function [  ] = saveImage( fname, xdim, ydim )
%SAVEIMAGE Saves a figure.
%   Saves the current figure as a .png file with filename "fname", a
%   width of "xdmin" pixels, and a height of "ydim" pixels. Usage:
%
%      [  ] = saveImage( fname, xdim, ydim )
%
%   If the destination path does not exist, then it is generated


[path, ~, ~] = fileparts(fname);
if ~exist(path, 'dir'),
    mkdir(path);
end
set(gcf,'PaperUnits','inches','PaperPosition',[0 0 xdim/100 ydim/100])
print('-dpng', '-r100', fname);

end

