% An implementation of the randomized max algorithm which is optimal
% unconstrined submodular maximization. Since the result is in expectation
% we run this multiple time

function OPTset = sfo_randomgreedymax(f,V,numiter, opt) 
    if ~exist('opt','var')
        opt = sfo_opt;
    end
    n=length(V);
    TOL = sfo_opt_get(opt,'ls_tolerance',1e-6);
    A = [];
    B = V;
    for i = 1 : length(V)
	alpha = max(f([A, i]) - f(A), 0);
	beta = max(f(sfo_setdiff_fast(B, i)) - f(B), 0);
	p = alpha/(alpha + beta);
	if (binornd(1, p) == 1)
            A = [A, i];
        else 
            B = sfo_setdiff_fast(B, i);
    end	
    OPTset = A;
end