function F = sfo_reward_disparity(sim, clusters)
fn = @(A) reward_disparity(A, sim, clusters);
F = sfo_fn_wrapper(fn);
end

function T = reward_disparity(A, sim, clusters)
	[numclusters numiterations] = size(clusters);
    T = 0;
    [m n] = size(sim);
    for j = 1 : numiterations
        for i = 1 : numclusters
            X = intersect(A, clusters(i).elements);
            % - The average sum reward term
            C = sum(sum(sim(X,:),1))/m; 
            % The inter-cluster best representative reward term
            % C = sum(sum(sim(X,clusters(i).elements),1))/length(clusters(i).elements);
            T = T + sqrt(C);
        end
    end
    T = T/numiterations;
end