function X = sfo_subsupinterface(F, G, V, Ff, Gf)
% An interface function that calls all variants of submodular supermodular
% and returns the best.
% This is all for the problem, \max_{X \subseteq V} F(X) - G(X).
X = [];
ModMod1 = sfo_modmodimproveduc(F, G, V, 1);
ModMod2 = sfo_modmodimproveduc(F, G, V, 2);
SupSub1 = sfo_supsubimproveduc(F, G, V, 1);
SupSub2 = sfo_supsubimproveduc(F, G, V, 2);
SubSup1 = sfo_subsupimproveduc(F, G, V, 1);
SubSup2 = sfo_subsupimproveduc(F, G, V, 2);

if (F(ModMod1) - G(ModMod1) > F(X) - G(X))
    X = ModMod1;
end
if (F(ModMod2) - G(ModMod2) > F(X) - G(X))
    X = ModMod2;
end
if (F(SupSub1) - G(SupSub1) > F(X) - G(X))
    X = SupSub1;
end
if (F(SupSub2) - G(SupSub2) > F(X) - G(X))
    X = SupSub2;
end
if (F(SubSup1) - G(SubSup1) > F(X) - G(X))
    X = SupSub1;
end
if (F(SubSup2) - G(SubSup2) > F(X) - G(X))
    X = SupSub2;
end
    
% Versions initializing with the Greedy
% H = sfo_difference(F, G);
H = sfo_fn_wrapper(@(S) Ff.eval(S) + Gf.eval(S));
XG = sfo_greedy_actual(H, V);
ModMod1 = sfo_modmodimproveduc(F, G, V, 1, XG);
ModMod2 = sfo_modmodimproveduc(F, G, V, 2, XG);
SupSub1 = sfo_supsubimproveduc(F, G, V, 1, XG);
SupSub2 = sfo_supsubimproveduc(F, G, V, 2, XG);
SubSup1 = sfo_subsupimproveduc(F, G, V, 1, XG);
SubSup2 = sfo_subsupimproveduc(F, G, V, 2, XG);

if (F(ModMod1) - G(ModMod1) > F(X) - G(X))
    X = ModMod1;
end
if (F(ModMod2) - G(ModMod2) > F(X) - G(X))
    X = ModMod2;
end
if (F(SupSub1) - G(SupSub1) > F(X) - G(X))
    X = SupSub1;
end
if (F(SupSub2) - G(SupSub2) > F(X) - G(X))
    X = SupSub2;
end
if (F(SubSup1) - G(SubSup1) > F(X) - G(X))
    X = SupSub1;
end
if (F(SubSup2) - G(SubSup2) > F(X) - G(X))
    X = SupSub2;
end

