function [ losses ] = surrogateLoss( evalSummaries, bow, bowSummaries )
%SURROGATELOSS Summary of this function goes here
%   Detailed explanation goes here

bowSummaries = bowSummaries';
nrWords = size(bow, 1);
nrEvalSummaries = size(evalSummaries, 1);

% compute alpha
alpha = zeros(nrWords, 1);
for w = 1:nrWords,
    tmp = sort(bow(w,:));
    alpha(w) = sum(tmp((end-9):end));
end

% compute bow for evalSummaries
bowEvalSummaries = zeros(nrWords, nrEvalSummaries);
for s = 1:nrEvalSummaries,
    bowEvalSummaries(:,s) = sum(bow(:,evalSummaries(s,:)), 2);
end

% compute losses
normalization = 2 * sum(alpha) * size(bowSummaries, 2);
losses = zeros(nrEvalSummaries, 1);
for s = 1:nrEvalSummaries,
    tmp  = min(repmat(bowEvalSummaries(:,s), 1, size(bowSummaries,2)), repmat(alpha, 1, size(bowSummaries, 2)) - bowSummaries);
    tmp2 = min(repmat(alpha - bowEvalSummaries(:,s), 1, size(bowSummaries,2)), bowSummaries);
    losses(s) = sum(tmp(:)) + sum(tmp2(:));
end

losses = losses / normalization;

end

