clear all;
clc;

ds = 1;
th = 0.1;
    
% setup loss
summaries = load_summaries(ds);

% setup evaluation
bowLoss = load_resource('bow', 'overfeat/slidingInputWindow', ds);
for img = 1:100,
    bowLoss(:,img) = bowLoss(:,img) / norm(bowLoss(:,img), 1);
end
summariesAsBOW = computeBOWSummary(summaries, bowLoss);

% setup evaluation
evaluationType = 'rouge';
options = struct();
options.bow = bowLoss;
options.summariesAsBow = summariesAsBOW; 

% compute overlap
rand('seed', 123456);
randomSummaries = randomSummary(100, 10, 1000);

[~,scHuman] = summaryEvaluation(summaries, summaries, evaluationType, options); 
[~,scRandom] = summaryEvaluation(randomSummaries, summaries, evaluationType, options); 
mean(scHuman)
mean(scRandom)

overlap = computeOverlapModified(scHuman, scRandom);
overlapOrig = computeOverlap(scHuman, scRandom);
fprintf(1, 'OVERLAP: %f\n', overlap);
fprintf(1, 'OVERLAP orig: %f\n', overlapOrig);
